


local textimput =require("scripts.textimput")
local disptextimput = false
local showlegend = true
local mtatl=require("scripts.timer")
local screan_setup = require("scripts.screan_setup")
local world_setup = require("scripts.world_setup")
local texture_setup = require("scripts.texture_setup")
local screan = screan_setup.load()
local world = world_setup.load()
local texture = texture_setup.load()
texture_setup.aplay(world,0,texture)

local vm = {w=0,h=0,d1=0,d2=0,d3=0} -- raycaster
local dirinfo = {
[270] = {d="u",l=180,r=360,is={true,false,false,false}},
[0] = {d="r",l=270,r=90,is={false,false,false,true}},
[360] = {d="r",l=270,r=90,is={false,false,false,true}},
[180] = {d="l",l=90,r=270,is={false,false,true,false}},
[90] = {d="d",l=0,r=180,is={false,true,false,false}},
} --controlls

local pla = {
	atype = "pla",
	grid_x = 2*32+16,
	grid_y = 2*32+16,
	act_x = 2*32+16,
	act_y = 2*32+16,
	speed = 2,
	r=0,
	ismoving = {x=false,y=false,overal=false,overalstate=true},
	g_r = 0,
	dir = "r",
	ll=false,
	rr=false,
	uu=false,
	dd=false,
	sl=false,
	sr=false
} --entity
local bots = {} --entity
for i=1,10 do --entity
	bots[i] = {
		atype = "bot",
		subtype = "",
		alive = true,
		i = 1,
		spawn_x= 5*32+16,
		spawn_y= 5*32+16,
	    	grid_x = 5*32+16,
       		grid_y = 5*32+16,
       		act_x = 5*32+16,
       		act_y = 5*32+16,
		ismoving = {x=false,y=false,overal=false,overalstate=true},
		draw_x = 0,
       		draw_y = 0,
       		speed = 1,
	   	r = 0,
		g_r = 0,
		dir = "r",
		visible = true,
		comp = "calc",
		dynamic = 0,
		prevdynamic = 0,
		animtime = 0.2,
		curanimtime = 0.2,
		animstate = 0,
		maxanimstate = 2
        }
end

function createchest(x,y,r) --entity
	world.map[y][x].col = 10
	return {
		atype = "chest",
		act_x = x*32+16,
       		act_y = y*32+16,
		r = r,
		visible = true,
		animstate = 0,
	}
end

local chests = {}
for i=1,#world.static_spawn do
	chests[(world.static_spawn[i].y-1)*#world.map[1]+world.static_spawn[i].x] = createchest(world.static_spawn[i].x,world.static_spawn[i].y,90*i)
end

local mapdraw = love.graphics.newCanvas(320,200) --hud
function rendernewmap() --hud
	mapdraw:clear()
	love.graphics.setColor(255,255,255)
	mapdraw:renderTo( function()
		for y=1,#world.map do
			for x=1,#world.map[1] do
				if world.map[y][x].col == 1 then
					love.graphics.rectangle("fill",32+x*8,32+y*8,8,8)
				end
			end
		end
	end )
end
rendernewmap() --hud

function setisplayermowing(elem,state,dir) --engine/AI
    if elem.ismoving then
	elem.ismoving[dir] = state
	elem.ismoving.overal = (elem.ismoving.x  or elem.ismoving.y)
   end
end

function rotateElement(p,dt) --engine/AI
	local g_r = p.g_r
	if p.atype == "bot" then
		g_r = p.g_r*90
	end
	if p.dir == "l" then
		p.r=p.r-dt*3*32
		if p.r <= 0 then
			g_r = 360
		end
		if p.r <= g_r then
			p.r = g_r
		end
	else
		p.r=p.r+dt*3*32
		if p.r >= 360 then
			g_r = 0
		end
		if p.r >= g_r then
			p.r = g_r
		end
	end
	if p.atype == "bot" then
		p.g_r = g_r/90
	else
		p.g_r = g_r
	end
end

function moveElement(elem,dt,dir) -- engine
   if not dir then
	moveElement(elem,dt,"x")
	moveElement(elem,dt,"y")
   else
  	 if elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt) and elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt) then
 	     elem["act_"..dir] = elem["grid_"..dir]
	     setisplayermowing(elem,false,dir)
 	  elseif not (elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] - 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  elseif not (elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] + 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  end
   end
end

function moveGrid(elem,dir1,dir2,dir3,dir4) -- engine
	if elem.act_y == elem.grid_y and elem.act_x == elem.grid_x  then
        	elem["grid_"..dir1] = elem["grid_"..dir1] + dir2
	end
end

local point = {} --raycasting
local fpoint={} --raycasting
local cpoint={} --raycasting

function positive(dir,r) --raycasting
	if r >= 0 and r <=90 and dir == "x" then
		return true
	elseif r > 0 and r <=90 and dir == "y" then
		return true
	elseif r > 90 and r <=180 and dir == "x" then
		return false
	elseif r > 90 and r <=180 and dir == "y" then
		return true
	elseif r > 180 and r <=270 and dir == "x" then
		return false
	elseif r > 180 and r <=270 and dir == "y" then
		return false
	elseif r > 270 and r <=361 and dir == "x" then
		return true
	elseif r > 270 and r <=361 and dir == "y" then
		return false
	end
end

function distance(x1,y1,x2,y2) -- utility/raycasting
	return ((x2-x1)^2+(y2-y1)^2)^0.5
end

function castRay(pr,cos_rr,id) --raycasting
		local plax,play = pla.act_x,pla.act_y
		local poixx,poiyx,poixy,poiyy 
		local rad_r = math.rad(pr)
		local tan_r = math.tan(rad_r)
		local nothit = true
		local ya = 0
		local xa = 32/tan_r
		local floorplay = math.floor(play/32)
		if not positive("y",pr) then
			poiyy = floorplay*32-0.01
			ya=-32
			xa = 0 - xa
		else
			poiyy = floorplay*32+32
			ya=32
		end
		poixy = plax+(poiyy -play) /tan_r
		local county = 0
		
		while nothit do
			local floorpoiyy,floorpoixy = math.floor(poiyy/32),math.floor(poixy/32)
			if world.map[floorpoiyy] and world.map[floorpoiyy][floorpoixy] and world.map[floorpoiyy][floorpoixy].col == 1 then
				nothit = false
			elseif not world.map[floorpoiyy] or (world.map[floorpoiyy] and not world.map[floorpoiyy][floorpoixy]) then
				nothit = false
			elseif county == 15 then
				nothit = false
			else
				poiyy = poiyy + ya
				poixy = poixy + xa
				county = county + 1
			end
			
			
		end
		nothit = true
		xa = 0
		ya = 32*tan_r
		local floorplax= math.floor(plax/32)
		if positive("x",pr) then
			poixx = floorplax*32+32
			xa=32
		else
			poixx = floorplax*32-0.01
			xa=-32
			ya = 0 - ya
		end
		poiyx = play+(poixx -plax)* tan_r
		countx = 0
		
		while nothit do
			local floorpoiyx,floorpoixx = math.floor(poiyx/32),math.floor(poixx/32)
			if world.map[floorpoiyx] and world.map[floorpoiyx][floorpoixx] and world.map[floorpoiyx][floorpoixx].col == 1 then
				nothit = false
			elseif not world.map[floorpoiyx] or (world.map[floorpoiyx] and not world.map[floorpoiyx][floorpoixx]) then
				nothit = false
			elseif countx == 15 then
				nothit = false
			else
				poixx = poixx + xa
				poiyx = poiyx + ya
				countx = countx + 1
			end
			
			
		end
		
		local d1,d2 = distance(plax,play,poixy,poiyy)* cos_rr,distance(plax,play,poixx,poiyx)* cos_rr
		if d1 < d2 then
			if county == 15 then
				d1 = 0
			else
				d1 = 32/d1*screan.camdist
			end
			
			return math.floor(poixy/32),math.floor(poiyy/32),d1,"y",math.floor((math.floor(poixy/32)+1-poixy/32)*64),cos_rr
		else
			if countx == 15 then
				d2 = 0
			else
				d2 = 32/d2*screan.camdist
			end
			
			return math.floor(poixx/32),math.floor(poiyx/32),d2,"x",math.floor((math.floor(poiyx/32)+1-poiyx/32)*64),cos_rr
		end
end

function testBotMap(p,x,y) --engine/controlls
	local px,py = (p.grid_x -16)/32,(p.grid_y -16)/32
	if world.map[py+y][px+x].col >0 then
		return false
	end
	return true
end

function testMonsterMap(bot,dirlst) --AI
	local validdirtab = {}
	local blocked = true
	for i=1,3 do
		local x,y = dirlst[i].x,dirlst[i].y
		if world.map[(bot.grid_y-16)/32+y][(bot.grid_x-16)/32+x].col == 0 and not world.dynamicmap[((bot.grid_y-16)/32+y-1)*#world.map[1]+(bot.grid_x-16)/32+x] and not world.prevdynamicmap[((bot.grid_y-16)/32+y-1)*#world.map[1]+(bot.grid_x-16)/32+x] then 
			blocked = false
			validdirtab[#validdirtab+1] = dirlst[i]
		end
	end
	if blocked then
		if bot.g_r == 0 and dirlst[4].dirid == "l" then
			bot.r = 360
		end
		if bot.g_r == 4 and dirlst[4].dirid == "r" then
			bot.r = 0
		end
		bot.g_r = dirlst[4].dir
		bot.dir = dirlst[4].dirid
	else
		local rand = math.random(1,#validdirtab)
		if bot.g_r == 0 and validdirtab[rand].dirid == "l" then
			bot.r = 360
		end
		if bot.g_r == 4 and validdirtab[rand].dirid == "r" then
			bot.r = 0
		end
		bot.g_r = validdirtab[rand].dir
		bot.dir = validdirtab[rand].dirid
	end
	
end
local rendernum = 0 --engine-draw
--do
function setupfloor() --raycasting
	--isframe = false
	local j = 0
	fpoint = {}
	cpoint = {}
	local tempfloorpoint = {}
	local scxcount = 1
	local d = 32/479*screan.camdist + vm.d1--math.max(point[1].d,32/479*screan.camdist)
	
	while screan.h_h-1 + d + 1*j <= screan.h+1 do
		local sc = screan.camdist*(16+vm.h)/((d+vm.d2)+j)
		local sc2 = math.floor(sc*2)
		
		if sc2 > texture.range2-1 then sc2 = texture.range2-1 end
		if sc2 < 0 then sc2 = 0 end
		scxcount = scxcount + 1
		if not tempfloorpoint[sc2] then --11.03,19.93
			fpoint[#fpoint+1]={i=sc2,sc=32/sc*screan.camdist *11.03 ,d=32/sc*screan.camdist/texture.range2 *19.93 ,y=screan.h_h + d + 1*j,scx=scxcount,y2=screan.h-(screan.h_h + d + 1*j),l=32/sc*screan.camdist/2}
			scxcount = 1
		end
		tempfloorpoint[sc2] = true
		j=j+1
	end
	d = d-2*vm.d1
	tempfloorpoint = {}
	scxcount = 1
	j=0
	while screan.h_h-1 + d + 1*j <= screan.h+1 do
		local sc = screan.camdist*(16-vm.h)/((d-vm.d2)+j)
		local sc2 = math.floor(sc*2)
		
		if sc2 > texture.range2-1 then sc2 = texture.range2-1 end
		if sc2 < 0 then sc2 = 0 end
		scxcount = scxcount + 1
		if not tempfloorpoint[sc2] then --11.03,19.93
			cpoint[#cpoint+1]={i=sc2,sc=32/sc*screan.camdist *11.03 ,d=32/sc*screan.camdist/texture.range2 *19.93 ,y=screan.h_h + d + 1*j,scx=scxcount,y2=screan.h-(screan.h_h + d + 1*j),l=32/sc*screan.camdist/2}
			scxcount = 1
		end
		tempfloorpoint[sc2] = true
		j=j+1
	end
end
setupfloor() --raycasting
local fpslimit = 60 --engine/limiter
local tempdt = 0 --engine/limiter
local tempdttodisplay = 0 --engine/hud/limiter
local botdecisionset = {[0]={{x=0,y=-1,dir=0,dirid="r"},{x=1,y=0,dir=1,dirid="r"},{x=-1,y=0,dir=3,dirid="l"},{x=0,y=1,dir=2,dirid="r"}},[2]={{x=0,y=1,dir=2,dirid="r"},{x=-1,y=0,dir=3,dirid="r"},{x=1,y=0,dir=1,dirid="l"},{x=0,y=-1,dir=0,dirid="l"}},[3]={{x=-1,y=0,dir=3,dirid="r"},{x=0,y=-1,dir=4,dirid="r"},{x=0,y=1,dir=2,dirid="l"},{x=1,y=0,dir=1,dirid="l"}},[1]={{x=1,y=0,dir=1,dirid="r"},{x=0,y=1,dir=2,dirid="r"},{x=0,y=-1,dir=0,dirid="l"},{x=-1,y=0,dir=3,dirid="r"}},[4]={{x=0,y=-1,dir=4,dirid="l"},{x=1,y=0,dir=1,dirid="r"},{x=-1,y=0,dir=3,dirid="l"},{x=0,y=1,dir=2,dirid="l"}}} -- AI/cintrolls - utility?
function love.update(dt)
     mtatl.timerUpdate(dt) --timer
     tempdt = tempdt + dt --engine/limiter
     if tempdt >= 1/fpslimit then --engine/limiter
	dt = tempdt --engine/limiter
	tempdttodisplay = math.floor(1/tempdt) --engine/limiter
	tempdt = 0 --engine/limiter
	point = {} --raycasting
	if pla.act_y ~= pla.grid_y or pla.act_x ~= pla.grid_x  then --engine/controlls
		moveElement(pla,dt)
	end
	if pla.r ~= pla.g_r then --engine/controlls
		rotateElement(pla,dt)
	end
	if pla.r == pla.g_r and (not pla.ismoving.overal) then --engine/controlls
    		if pla.uu then
			if dirinfo[pla.g_r].is[1] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.dd then
			if dirinfo[pla.g_r].is[2] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0) end
		end
		if pla.sl then
			if dirinfo[pla.g_r].is[4] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.sr then
			if dirinfo[pla.g_r].is[3] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.ll then
			pla.g_r = dirinfo[pla.g_r].l
			pla.dir = "l"
		end
		if pla.rr then
			pla.g_r = dirinfo[pla.g_r].r
			pla.dir = "r"
		end
	end
	
	local temppoint = {} --raycasting
	for i = -50,2*screan.c_w+50 do --raycasting
		local pr = pla.r + (i-screan.c_w)*screan.column
		local pr2 = pr - pla.r
		if pr >= 360 then
			pr = pr - 360
		end
		if pr <= 0 then
			pr = 360 + pr
		end
		if pr2 >= 360 then
			pr2 = pr2 - 360
		end
		if pr2 <= 0 then
			pr2 = 360 + pr2
		end
		local rad_rr = math.rad(pr2)
		local cos_rr = math.cos(rad_rr)
		if i >0 and i <= 2*screan.c_w then
			local x,y,d,dir,c,cos = castRay(pr,cos_rr,i)
			point[i]={x=x or 1,y=y or 1,d=d or 0,dir=dir or "y",c=c,id=i,r=pr}
		end
		temppoint[math.floor(pr*screan.subang)] = {id=i,cos=cos_rr}
	end
	for i,bot in pairs(bots) do --engine/AI
	  if bot.alive then
		if not bot.ismoving.overal and bot.r == bot.g_r*90 and bot.act_y == bot.grid_y and bot.act_x == bot.grid_x then
			
			testMonsterMap(bot,botdecisionset[bot.g_r])
			
			if bot.g_r == 0 then moveGrid(bot,"y",-32,0,1)
			elseif bot.g_r == 2 then moveGrid(bot,"y",32,0,-1)
			elseif bot.g_r == 3 then moveGrid(bot,"x",-32,1,0)
			elseif bot.g_r == 1 then moveGrid(bot,"x",32,-1,0) 
			elseif bot.g_r == 4 then moveGrid(bot,"y",-32,0,1) end
			--bot.speed = flormomsters[1][bot.subtype][2]
			world.prevdynamicmap[bot.prevdynamic] = nil
			world.prevdynamicmap[bot.dynamic] = dynamicmap[bot.dynamic]
			bot.prevdynamic = bot.dynamic
			world.dynamicmap[bot.dynamic] = nil
			world.dynamicmap[((bot.grid_y-16)/32-1)*#world.map[1]+(bot.grid_x-16)/32] = bot
			bot.dynamic = ((bot.grid_y-16)/32-1)*#world.map[1]+(bot.grid_x-16)/32
			
			
			
		end
		if bot.curanimtime > 0 then
			bot.curanimtime = bot.curanimtime - dt
		else
			bot.curanimtime = bot.animtime
			bot.animstate = bot.animstate + 1
			if bot.animstate > bot.maxanimstate then
				bot.animstate = 0
			end
		end
		local xinc = bot.act_y-pla.act_y
		local yinc = bot.act_x-pla.act_x
		local radang = math.floor(math.deg(math.atan2(xinc,yinc))*screan.subang)
		if radang < 0 then
			radang = radang + 360*screan.subang
		end
		local imgangle = pla.r-bot.r-90
		if imgangle < -360 then
			imgangle = imgangle + 2*360
		elseif imgangle < 0 then
			imgangle = imgangle + 360
		end
		local imgid = math.floor((imgangle)/45)
		if temppoint[radang] then
			point[#point+1] = {x=0 or 0,y=0 or 0,d=32/(distance(pla.act_y,pla.act_x,bot.act_y,bot.act_x)*temppoint[radang].cos)*screan.camdist or 0,dir="f",c=0,id=temppoint[radang].id,img=texture.ratimgT[bot.animstate][imgid] or texture.ratimgT[0][0],bot=bot,img2=texture.ratimg}
		end
		if (bot.act_y ~= bot.grid_y or bot.act_x ~= bot.grid_x) then
			if bot.r == bot.g_r*90 then
				moveElement(bot,dt)
			else
				rotateElement(bot,dt)
			end
		end
		
	  end
		    
	end
	for i,c in pairs(chests) do --entity/statics
		local xinc = c.act_y-pla.act_y
		local yinc = c.act_x-pla.act_x
		local radang = math.floor(math.deg(math.atan2(xinc,yinc))*screan.subang)
		if radang < 0 then
			radang = radang + 360*screan.subang
		end
		local imgangle = pla.r-c.r-90
		if imgangle < -360 then
			imgangle = imgangle + 2*360
		elseif imgangle < 0 then
			imgangle = imgangle + 360
		end
		local imgid = math.floor((imgangle)/45)
		if temppoint[radang] then
			point[#point+1] = {x=0 or 0,y=0 or 0,d=32/((distance(pla.act_y,pla.act_x,c.act_y,c.act_x)-10)*temppoint[radang].cos)*screan.camdist or 0,dir="f",c=0,id=temppoint[radang].id,img=texture.chestimgT[c.animstate][imgid] or texture.ratimgT[0][0],chest=c,img2=texture.chestimg}
		end
	end	
	table.sort(point,function(a,b) return a.d<b.d end) --raycasting - postprocess

	while point[1].dir == "f" do --raycasting - postprocess
		table.remove(point,1)
	end 
	local fx, fy, fa, fox, foy = texture.fullfloortodraw:getWidth()/2 , texture.fullfloortodraw:getHeight(), math.rad(-pla.r-90), (pla.act_x-32), (pla.act_y-32) --raycasting - postprocess
	texture.fullfloortodraw:clear()
	
	texture.fullfloortodraw:renderTo(function() --raycasting - postprocess
			love.graphics.setColor(255,255,255)
			love.graphics.draw(texture.fullfloor,fx,fy,fa,1,1,fox,foy)
	end)
	texture.fullceltodraw:clear() --raycasting - postprocess
	
	texture.fullceltodraw:renderTo(function() --raycasting - postprocess
			love.graphics.setColor(255,255,255)
			love.graphics.draw(texture.fullcel,fx,fy,fa,1,1,fox,foy)
	end)
	local d = math.max(point[1].d,32/479*screan.camdist) --raycasting - postprocess
	rendernum = 2*screan.camdist*16/d --raycasting - postprocess
   
  end
  if disptextimput then
	textimput.update(dt)
  end
end

function love.draw()
	
	love.graphics.setColor(255,255,255)-- level-draw
	local nfpoint = 0
	local ncpoint = 0
	local nwpoint = screan.h_w
	local nspr = 0
	for i=1, #fpoint do
		if fpoint[i].i < rendernum then
			local lightcolor = math.max(math.min(math.floor(fpoint[i].l+texture.light_l),255),0)
			love.graphics.setColor(lightcolor,lightcolor,lightcolor)
			if texture.disp_s.f then
				
				love.graphics.drawq(texture.fullfloortodraw, texture.fullfloortodrawQuad[fpoint[i].i], screan.h_w-fpoint[i].sc, fpoint[i].y, 0,fpoint[i].d ,fpoint[i].scx , 0, 0, 0, 0 )
			end
			nfpoint = nfpoint + 1
		end
	end
	for i=1, #cpoint do
		if cpoint[i].i < rendernum then	
			local lightcolor = math.max(math.min(math.floor(cpoint[i].l+texture.light_l),255),0)
			love.graphics.setColor(lightcolor,lightcolor,lightcolor)
			if texture.disp_s.c then
				love.graphics.drawq(texture.fullceltodraw, texture.fullceltodrawQuad[cpoint[i].i], screan.h_w-cpoint[i].sc, cpoint[i].y2, 0,cpoint[i].d ,cpoint[i].scx , 0, 0, 0, 0 )
			end
			ncpoint = ncpoint + 1
		end
	end
	
	for i = 1,#point do
		local lightcolor = math.max(math.min(math.floor(point[i].d+texture.light_l),255),0)
		love.graphics.setColor(lightcolor,lightcolor,lightcolor)
		
		local x = point[i].id*2 
		local y1 = screan.c_h + point[i].d/2
		local y2 = screan.c_h*2 - point[i].d + vm.w*point[i].d/50 + vm.d3
		if point[i].dir == "f" then
			love.graphics.drawq(point[i].img2,point[i].img, x-point[i].d, y2, 0, point[i].d/32, point[i].d/32, 0, 0, 0, 0)
		  
		elseif point[i].dir == "x" and texture.disp_s.w then 
			love.graphics.drawq( texture.textures, texture.slicewallimg[(64-point[i].c)+64*world.map[point[i].y][point[i].x].x] or texture.slicewallimg[1+64*world.map[point[i].y][point[i].x].x], x, y2, 0, 2, (point[i].d)/32, 0, 0, 0, 0 )
		elseif texture.disp_s.w then
			love.graphics.drawq( texture.textures, texture.slicewallimg[(64-point[i].c)+64*world.map[point[i].y][point[i].x].y] or texture.slicewallimg[1+64*world.map[point[i].y][point[i].x].y], x, y2, 0, 2, (point[i].d)/32, 0, 0, 0, 0 )
		end
		nspr = nspr + 1
	end

	love.graphics.setColor(255,0,0) -- hud-draw
	love.graphics.printf("FPS: "..love.timer.getFPS().."; CPS: "..tempdttodisplay.."; CPS limit: "..fpslimit.."; rendering: floor= "..nfpoint..", ceiling="..ncpoint..", wall="..nwpoint..", sprite="..nspr-nwpoint..", overall="..nfpoint+ncpoint+nspr.."; Light="..texture.light_l.."; tilt ="..vm.d3.."; elevation="..vm.w,5,5,screan.w-10)
	love.graphics.draw(mapdraw,0,0)
	love.graphics.circle("fill",32+pla.act_x/4,32+pla.act_y/4,3)
	love.graphics.setColor(0,255,0,100)
	
	love.graphics.setColor(0,0,255,255)
	
	for i,bot in pairs(bots) do
		love.graphics.circle("fill",32+bot.act_x/4,32+bot.act_y/4,3)
	end
	if disptextimput then
		textimput.draw(screan)
  	end
	if showlegend then
		love.graphics.setColor(0,0,0,255)
		love.graphics.rectangle("fill",20,20,screan.w-40,screan.h-40)
		love.graphics.setColor(255,255,255,255)
		love.graphics.printf([[Legend:
			Read dot on minimap = player
			Blue dot on minimap = bot
			FPS = Frames per second
			CPS = calculations per second (game tics per second)
			Rendering = amount of images drawn on the screen
			Light = lighting modifier
			Tilt = player head tilt
			Elevation = player eye elevation
			Keys: 
			Move = arrow keys or q,w,e,a,s,d
			Textures= 1,2,3,4
			Resolution = r
			Lighting = '-','='
			Elevation = num+, num-
			Tilt = num/, num*
			CPS limit = num1,num2
			Toggling wall, ceiling, floor = 8,9,0
			Toggling the legend = esc]],30,30,screan.w-30)
	end
end
local newW= 0
function getscreenheight(scr_H)
	disptextimput = false
	screan = screan_setup.load(tonumber(newW),tonumber(scr_H))
	texture_setup.aplay(world,0,texture)
	setupfloor()
	rendernewmap()
end
function getscreenwight(scr_w)
	newW = scr_w
	local keytab = {"1","2","3","4","5","6","7","8","9","0","kp1","kp2","kp3","kp4","kp5","kp6","kp7","kp8","kp9","kp0",}
	local morespecialkeytab ={["kp1"]="1",["kp2"]="2",["kp3"]="3",["kp4"]="4",["kp5"]="5",["kp6"]="6",["kp7"]="7",["kp8"]="8",["kp9"]="9",["kp0"]="0",}
	textimput.setup(getscreenheight,keytab,morespecialkeytab,"Enter screen height",3,4)
end

function love.keypressed(key) --controlls
    if disptextimput then
	textimput.key(key)
    else
	if key == "left" then
    		pla.ll = true
	elseif key == "right" then
    		pla.rr = true
	elseif key == "up" then
    		pla.uu = true
	elseif key == "down" then
    		pla.dd = true
	elseif key == "a" then
    		pla.ll = true
	elseif key == "d" then
    		pla.rr = true
	elseif key == "w" then
    		pla.uu = true
	elseif key == "s" then
    		pla.dd = true
	elseif key == "q" then
    		pla.sl = true
	elseif key == "e" then
    		pla.sr = true
	elseif key == "1" then	
		texture_setup.aplay(world,1,texture)
	elseif key == "2" then	
		texture_setup.aplay(world,2,texture)
	elseif key == "3" then	
		texture_setup.aplay(world,3,texture)
	elseif key == "4" then	
		texture_setup.aplay(world,4,texture)
	elseif key == "-" then	
		local keyiter
		function keyiter()
			if love.keyboard.isDown("-") then
				texture.light_l = texture.light_l - 1
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "=" then	
		local keyiter
		function keyiter()
			if love.keyboard.isDown("=") then
				texture.light_l = texture.light_l + 1 -- 
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "8" then	
		texture_setup.update_s(texture,"w")
	elseif key == "9" then	
		texture_setup.update_s(texture,"f")
	elseif key == "0" then	
		texture_setup.update_s(texture,"c")
	elseif key == "kp+" then
		local keyiter
		function keyiter()
			if vm.w < 30 and love.keyboard.isDown("kp+") then	
				vm.w=vm.w+0.5
				vm.h=vm.h+0.16
				vm.d1=vm.d1+0.2
				setupfloor()
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "kp-" then
		local keyiter
		function keyiter()
			if vm.w > -30 and love.keyboard.isDown("kp-") then	
				vm.w=vm.w-0.5
				vm.h=vm.h-0.16
				vm.d1=vm.d1-0.2
				setupfloor()
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "kp*" then
		local keyiter
		function keyiter()
			if vm.d3 < 120 and love.keyboard.isDown("kp*") then	
				vm.d3=vm.d3+1
				vm.d1=vm.d1+1
				vm.d2=vm.d2-1
				setupfloor()
				mtatl.setTimer(keyiter,0.05,1)
			end
		end
		keyiter()
	elseif key == "kp/" then
		local keyiter
		function keyiter()
			if vm.d3 > - 120 and love.keyboard.isDown("kp/") then	
				vm.d3=vm.d3-1
				vm.d1=vm.d1-1
				vm.d2=vm.d2+1
				setupfloor()
				mtatl.setTimer(keyiter,0.05,1)
			end
		end
		keyiter()
	elseif key == "kp1" then
		local keyiter
		function keyiter()
			if vm.d3 < 120 and love.keyboard.isDown("kp1") then	
				fpslimit = fpslimit + 1
				mtatl.setTimer(keyiter,0.8,1)
			end
		end
		keyiter()
	elseif key == "kp2" then
		local keyiter
		function keyiter()
			if vm.d3 > - 120 and love.keyboard.isDown("kp2") then	
				fpslimit = fpslimit - 1
				mtatl.setTimer(keyiter,0.8,1)
			end
		end
		keyiter()
	elseif key == " " then
		local x,y = (pla.grid_x-16)/32 + botdecisionset[pla.g_r/90][2].x, (pla.grid_y-16)/32 + botdecisionset[pla.g_r/90][2].y
		if world.dynamicmap[(y-1)*#world.map[1]+x] or world.prevdynamicmap[(y-1)*#world.map[1]+x] then
			return
		elseif chests[(y-1)*#world.map[1]+x] then
			if chests[(y-1)*#world.map[1]+x].animstate == 0 then
				chests[(y-1)*#world.map[1]+x].animstate = 1
			else
				chests[(y-1)*#world.map[1]+x].animstate = 0
			end
		elseif not (y == 1 or y == #world.map or x == 1 or x == #world.map[1]) then
			if world.map[y][x].col == 1 then
				world.map[y][x].col = 0
			elseif world.map[y][x].col == 0 then
				world.map[y][x].col = 1
			end
			rendernewmap()
		end
	elseif key == "r" then
		disptextimput = true
		local keytab = {"1","2","3","4","5","6","7","8","9","0","kp1","kp2","kp3","kp4","kp5","kp6","kp7","kp8","kp9","kp0",}
		local morespecialkeytab={["kp1"]="1",["kp2"]="2",["kp3"]="3",["kp4"]="4",["kp5"]="5",["kp6"]="6",["kp7"]="7",["kp8"]="8",["kp9"]="9",["kp0"]="0",}
		textimput.setup(getscreenwight,keytab,morespecialkeytab,"Enter screen width",3,4)
	elseif key == "escape" then
		showlegend = not showlegend	
	end
    end
end

function love.keyreleased(key) -- controlls
    if disptextimput then
	textimput.keyr(key)
    else
	if key == "left" then
    		pla.ll = false
	elseif key == "right" then
    		pla.rr = false
	elseif key == "up" then
    		pla.uu = false
	elseif key == "down" then
    		pla.dd = false
	elseif key == "a" then
    		pla.ll = false
	elseif key == "d" then
    		pla.rr = false
	elseif key == "w" then
    		pla.uu = false
	elseif key == "s" then
    		pla.dd = false
	elseif key == "q" then
    		pla.sl = false
	elseif key == "e" then
    		pla.sr = false	
	end
   end
end
