--this file sets up the parameters for screen size and the projection plane
return {
	load = function(w,h)
		local view_range = 60
		local h_view_range = view_range/2
		if not w or not h then
			w,h = love.graphics.getWidth(),love.graphics.getHeight() --640,400
		else
			love.graphics.setMode(w,h)
		end
		local h_w,h_h = w/2,h/2
		local subang = math.floor(h_w/64)
		if subang < 1 then
			subang = 1
		end
		local c_w,c_h = h_w/2,h_h/2
		local camdist = c_w/math.tan(math.rad(h_view_range))
		local column = view_range/h_w
		return {w=w,h=h,h_w=h_w,h_h=h_h,c_w=c_w,c_h=c_h,camdist=camdist,column=column,view_range=view_range,subang=subang}
	end
}