local map_setup=require("scripts.world_setup")
local fullfloor,fullcel --texture
local light_l = 0 --texture
local disp_s = {w=true,f=true,c=true} --texture
local textureslst = {} -- texture
local slicewallimg = {} --texture
local fullfloortodrawQuad = {} --texture
local fullceltodrawQuad = {} --texture
local ratimgT = {} --texture
local chestimgT = {} --texture

local maketransparent = function(file) -- texture
	love.graphics.setDefaultImageFilter( "nearest","nearest" )
	local ratimgdata = love.image.newImageData(file)
	for i=0,ratimgdata:getWidth()-1 do
		for j=0,ratimgdata:getHeight()-1 do
			local r,g,b,a = ratimgdata:getPixel(i,j)
			if r == 255 and g == 255 and b == 255 and a == 255 then
				ratimgdata:setPixel(i,j,255,255,255,0)
			end
		end
	end
	return love.graphics.newImage(ratimgdata)
end

return {
	load = function()
		love.graphics.setDefaultImageFilter( "nearest","nearest" ) --texture
		local textures = love.graphics.newImage("art/wolftextures.png") --texture

		for i=0, (textures:getWidth()/64)-1 do -- texture
			textureslst[i] = love.graphics.newQuad(64*i,0,64,64,textures:getWidth(),textures:getHeight())
		end
		--changetexture(3,true) --texture/level
		love.graphics.setDefaultImageFilter( "linear","linear" ) -- texture

		for i = 1, textures:getWidth() do --texture
			slicewallimg[i] = love.graphics.newQuad(i-1, 0, 1, 64, textures:getWidth(), 64 )
		end
		local range2 = 14*32*1.29--dim*1.29--math.floor(distance(0,0,dim,dim)) --raycasting/texture
		local fullfloortodraw = love.graphics.newCanvas(rande2, range2) --texture
		local fullceltodraw = love.graphics.newCanvas(rande2, range2) --texture

		for i = 0, fullfloortodraw:getHeight()-1 do --texture
			fullfloortodrawQuad[i] = love.graphics.newQuad(0, fullfloortodraw:getHeight()-i, fullfloortodraw:getWidth(), 1, fullfloortodraw:getWidth(), fullfloortodraw:getHeight())
		end

		for i = 0, fullceltodraw:getHeight()-1 do --texture
			fullceltodrawQuad[i] = love.graphics.newQuad(0, fullceltodraw:getHeight()-i, fullceltodraw:getWidth(), 1, fullceltodraw:getWidth(), fullceltodraw:getHeight())
		end
		fullfloortodraw:setFilter("nearest","nearest") --texture
		fullceltodraw:setFilter("nearest","nearest") --texture
		
		local ratimg = maketransparent("art/rat.png") -- texture
		local chestimg = maketransparent("art/chest.png") --texture

		for animstate = 0,2 do --texture
			ratimgT[animstate] = {}
			for rotation = 0,7 do
				ratimgT[animstate][rotation] = love.graphics.newQuad(64*animstate,64*rotation,64,64,ratimg:getWidth(),ratimg:getHeight())
			end
			ratimgT[animstate][8] = ratimgT[animstate][0]
		end

		for animstate = 0,2 do --texture
			chestimgT[animstate] = {}
			for rotation = 0,7 do
				chestimgT[animstate][rotation] = love.graphics.newQuad(64*animstate,64*rotation,64,64,chestimg:getWidth(),chestimg:getHeight())
			end
			chestimgT[animstate][8] = chestimgT[animstate][0]
		end
		
		return {fullfloor=fullfloor,fullcel=fullcel,light_l=light_l,disp_s=disp_s,textureslst=textureslst,slicewallimg=slicewallimg,fullfloortodrawQuad=fullfloortodrawQuad,fullceltodrawQuad=fullceltodrawQuad,ratimgT=ratimgT,chestimgT=chestimgT,fullfloortodraw=fullfloortodraw,fullceltodraw=fullceltodraw,range2=range2,ratimg=ratimg,chestimg=chestimg,textures=textures}
	end,
	aplay = function(w,mode,t)
		local state = false
		if mode == 0 then
			state = false
		elseif mode == 3 then
			local tempW = map_setup.load(w.map[1][1].id)
			w.map = tempW.map
			state = false
		else
			state = true
		end
		if state then
			for y=1,#w.map do
			
				for x=1,#w.map[1] do
					if mode == 1 then
						w.map[y][x].c = 0
						w.map[y][x].f = 0
			
						w.map[y][x].x = 0
						w.map[y][x].y = 0
				
					elseif mode == 2 then
						w.map[y][x].c = 5
						w.map[y][x].f = 5
			
						w.map[y][x].x = 5
						w.map[y][x].y = 5

				
					elseif mode == 4 then
						w.map[y][x].c = math.random(1,4)
						w.map[y][x].f = math.random(1,4)
			
						w.map[y][x].x = math.random(1,4)
						w.map[y][x].y = math.random(1,4)
				
					end
				end
			end
		end
		local dim = math.max(#w.map[1]*32,#w.map*32)
		t.fullfloor = love.graphics.newCanvas(dim,dim)
		t.fullfloor:renderTo(function()
			love.graphics.setColor(255,255,255)
			for y=1,#w.map do
				for x=1,#w.map[1] do
				
					love.graphics.drawq(t.textures,t.textureslst[w.map[y][x].f],(x-1)*32,(y-1)*32,0,0.5,0.5)
				
				end
			end
		end)
		t.fullcel = love.graphics.newCanvas(dim,dim)
		t.fullcel:renderTo(function()
			love.graphics.setColor(255,255,255)
			for y=1,#w.map do
				for x=1,#w.map[1] do
				
					love.graphics.drawq(t.textures,t.textureslst[w.map[y][x].c],(x-1)*32,(y-1)*32,0,0.5,0.5)
				
				end
			end
		end)
		--chests = {}
		--chests[(8-1)*#map[1]+4] = createchest(4,8,90)
		--chests[(10-1)*#map[1]+12] = createchest(12,10,180)
	end,
	update_s = function(t,n)
		t.disp_s[n] = not t.disp_s[n]
	end
}





